## refpolicy 0.0.20070507

=== Makefile ===
--- 
+++ 
@@ -108,7 +108,7 @@
 # documentation paths
 docs := doc
 xmldtd = $(docs)/policy.dtd
-layerxml = metadata.xml
+metaxml = metadata.xml
 doctemplate = $(docs)/templates
 docfiles = $(docs)/Makefile.example $(addprefix $(docs)/,example.te example.if example.fc)
 
@@ -194,11 +194,6 @@
 	M4PARAM += -D distro_redhat
 endif
 
-# enable polyinstantiation
-ifeq ($(POLY),y)
-	M4PARAM += -D enable_polyinstantiation
-endif
-
 ifneq ($(OUTPUT_POLICY),)
 	CHECKPOLICY += -c $(OUTPUT_POLICY)
 endif
@@ -259,6 +254,10 @@
 # when a generated file is already generated
 detected_mods := $(sort $(foreach dir,$(all_layers),$(wildcard $(dir)/*.te)) $(generated_te))
 
+modxml := $(detected_mods:.te=.xml)
+layerxml := $(addprefix $(tmpdir)/, $(notdir $(addsuffix .xml,$(all_layers))))
+all_metaxml := $(addsuffix /$(metaxml), $(all_layers))
+
 # modules.conf setting for base module
 configbase := base
 
@@ -372,4 +371,3 @@
 	@echo "#" >> $@
 	$(verbose) cat $@.in >> $@
 	$(verbose) $(GREP) "^[[:blank:]]*network_(interface|node|port|packet)\(.*\)" $< \
-		| $(M4) -D self_contained_policy $(M4PARAM) $@.m4 - \
