## refpolicy 0.0.20071214

=== Makefile ===
--- 
+++ 
@@ -158,18 +158,8 @@
 headerdir = $(modpkgdir)/include
 docsdir = $(prefix)/share/doc/$(PKGNAME)
 
-# compile strict policy if requested.
-ifneq ($(findstring strict,$(TYPE)),)
-	M4PARAM += -D strict_policy
-endif
-
-# compile targeted policy if requested.
-ifneq ($(findstring targeted,$(TYPE)),)
-	M4PARAM += -D targeted_policy
-endif
-
 # enable MLS if requested.
-ifneq ($(findstring -mls,$(TYPE)),)
+ifeq "$(TYPE)" "mls"
 	M4PARAM += -D enable_mls
 	CHECKPOLICY += -M
 	CHECKMODULE += -M
@@ -177,7 +167,7 @@
 endif
 
 # enable MLS if MCS requested.
-ifneq ($(findstring -mcs,$(TYPE)),)
+ifeq "$(TYPE)" "mcs"
 	M4PARAM += -D enable_mcs
 	CHECKPOLICY += -M
 	CHECKMODULE += -M
@@ -194,12 +184,19 @@
 	M4PARAM += -D distro_redhat
 endif
 
+ifeq "$(DISTRO)" "ubuntu"
+	M4PARAM += -D distro_debian
+endif
+
 ifneq ($(OUTPUT_POLICY),)
 	CHECKPOLICY += -c $(OUTPUT_POLICY)
 endif
 
 # if not set, use the type as the name.
 NAME ?= $(TYPE)
+
+# default unknown permissions setting
+#UNK_PERMS ?= deny
 
 ifeq ($(DIRECT_INITRC),y)
 	M4PARAM += -D direct_sysadm_daemon
@@ -238,12 +235,12 @@
 appdir := $(contextpath)
 user_default_contexts := $(wildcard config/appconfig-$(TYPE)/*_default_contexts)
 user_default_contexts_names := $(addprefix $(contextpath)/users/,$(subst _default_contexts,,$(notdir $(user_default_contexts))))
-appfiles := $(addprefix $(appdir)/,default_contexts default_type initrc_context failsafe_context userhelper_context removable_context dbus_contexts customizable_types) $(contextpath)/files/media $(user_default_contexts_names)
+appfiles := $(addprefix $(appdir)/,default_contexts default_type initrc_context failsafe_context userhelper_context removable_context dbus_contexts customizable_types securetty_types) $(contextpath)/files/media $(user_default_contexts_names)
 net_contexts := $(builddir)net_contexts
 
-all_layers := $(filter-out $(moddir)/CVS,$(shell find $(wildcard $(moddir)/*) -maxdepth 0 -type d))
-ifdef LOCAL_ROOT
-all_layers += $(filter-out $(local_moddir)/CVS,$(shell find $(wildcard $(local_moddir)/*) -maxdepth 0 -type d))
+all_layers := $(shell find $(wildcard $(moddir)/*) -maxdepth 0 -type d)
+ifdef LOCAL_ROOT
+all_layers += $(shell find $(wildcard $(local_moddir)/*) -maxdepth 0 -type d)
 endif
 
 generated_te := $(basename $(foreach dir,$(all_layers),$(wildcard $(dir)/*.te.in)))
@@ -254,9 +251,10 @@
 # when a generated file is already generated
 detected_mods := $(sort $(foreach dir,$(all_layers),$(wildcard $(dir)/*.te)) $(generated_te))
 
-modxml := $(detected_mods:.te=.xml)
-layerxml := $(addprefix $(tmpdir)/, $(notdir $(addsuffix .xml,$(all_layers))))
-all_metaxml := $(addsuffix /$(metaxml), $(all_layers))
+modxml := $(addprefix $(tmpdir)/, $(detected_mods:.te=.xml))
+layerxml := $(sort $(addprefix $(tmpdir)/, $(notdir $(addsuffix .xml,$(all_layers)))))
+layer_names := $(sort $(notdir $(all_layers)))
+all_metaxml = $(call detect-metaxml, $(layer_names))
 
 # modules.conf setting for base module
 configbase := base
@@ -345,6 +343,29 @@
 
 endef
 
+# detect-metaxml layer_names
+ifdef LOCAL_ROOT
+define detect-metaxml
+	$(shell for i in $1; do \
+		if [ -d $(moddir)/$$i -a -d $(local_moddir)/$$i ]; then \
+			if [ -f $(local_moddir)/$$i/$(metaxml) ]; then \
+				echo $(local_moddir)/$$i/$(metaxml) ;\
+			else \
+				echo $(moddir)/$$i/$(metaxml) ;\
+			fi \
+		elif [ -d $(local_moddir)/$$i ]; then
+			echo $(local_moddir)/$$i/$(metaxml) ;\
+		else \
+			echo $(moddir)/$$i/$(metaxml) ;\
+		fi \
+	done )
+endef
+else
+define detect-metaxml
+	$(shell for i in $1; do echo $(moddir)/$$i/$(metaxml); done)
+endef
+endif
+
 ########################################
 #
 # Load appropriate rules
@@ -364,10 +385,3 @@
 #
 generate: $(generated_te) $(generated_if) $(generated_fc)
 
-$(moddir)/kernel/corenetwork.if: $(moddir)/kernel/corenetwork.te.in $(moddir)/kernel/corenetwork.if.m4 $(moddir)/kernel/corenetwork.if.in
-	@echo "#" > $@
-	@echo "# This is a generated file!  Instead of modifying this file, the" >> $@
-	@echo "# $(notdir $@).in or $(notdir $@).m4 file should be modified." >> $@
-	@echo "#" >> $@
-	$(verbose) cat $@.in >> $@
-	$(verbose) $(GREP) "^[[:blank:]]*network_(interface|node|port|packet)\(.*\)" $< \
