=== debian/changelog ===
refpolicy (2:2.20110726-9) unstable; urgency=high

  * Enable UBAC as roles aren't useful.  I recommend using only roles user_r
    and unconfined_r and using UBAC (constraining users from sharing files
    between identities) where you would previously have used roles.
  * Made cron jobs run in regular user domains such as unconfined_t and user_t
    Closes: #679277
  * Had the wrong timestamp on the last upload, corrected it for the record.
  * Allow ftpd to create sock_file objects under /var/run for proftpd
  * Change readahead policy to support memlockd.
  * Allow devicekit_power_t, devicekit_disk_t, kerneloops_t, and policykit_t
    to send dbus messages to users.
  * Grant systemd utilities access to selinuxfs so they can correctly label directories
    Closes: #678392
  * Assigned type consolekit_var_run_t to /var/run/console(/.*)? because it's
    created and managed by consolekit nowadays.
  * Created tunable allow_ssh_connect_reserved_ports to allow ssh client to
    connect to reserved ports.
  * Correctly label all perdition binaries, give perdition_t dac_override, and
    allow perdition_t to create it's own pid directories.
  * Label /etc/dansguardian as squid_etc_t
  * Allow devicekit_power_t to access acpi device and read udev tables and
    allow devicekit_disk_t to read udev tables.
  * Allow sshd_t to write to fifos inherited from systemd
  * High urgency because we really need to have working cron jobs!!!
  * Removed the postinst code to upgrade from pre-squeeze packages.

 -- Russell Coker <russell@coker.com.au>  Sat, 30 Jun 2012 19:19:57 +1000

refpolicy (2:2.20110726-8) unstable; urgency=high

  * Allow dbus domains to search cgroup dirs and init_var_run_t
  * Have init_t transition to devicekit_power_t and devicekit_disk_t for
    systemd.
  * Allow user domains to create netlink_kobject_uevent_socket objects
  * Put dansguardian in squid_t
  * Fixed error in portslave.te that prevented module insertion
  * Allow postgrey_t to exec bin_t for perl and self:netlink_route_socket
    access
  * Allow dac_override access to arpwatch_t
  * Add tcsd.pp (for trousers) to the policy packages
  * Add nut.pp for the nut-server package to the policy packages
  * Load irqbalance.pp if irqbalance Debian package is installed, same for
    kerneloops, tcsd.pp/trousers, nut.pp/nut-server, 
    and smartmon.pp/smartmontools.
  * High urgency because the support for tcsd and nut really needs to be
    tested (and it's broken badly for those people) and portslave.pp is also
    badly broken in previous versions.

 -- Russell Coker <russell@coker.com.au>  Mon, 25 Jun 2012 16:37:45 +1000

refpolicy (2:2.20110726-7) unstable; urgency=high

  [Russell Coker]
  * Got Chromium working!
  * Allow user_dbusd_t to access /run/console
  * Got systemd working
    Closes: #677578
  * Added policy for dirmngr.
  * Added support for wide-dhcpv6-client.
  * Remove all refpolicyerr and almost all refpolicywarn instances, removed all
    obsolete interfaces and fixed syntax errors.
    Closes: #678237
  * Allow all users to run the Postfix mailq command
  * Lots of little changes.
  [Mika Pflüger]
  * Do not ship pyplate.pyc. Closes: #676852

 -- Russell Coker <russell@coker.com.au>  Thu, 21 Jun 2012 23:15:59 +1000

refpolicy (2:2.20110726-6) unstable; urgency=low

  * Added deny_ptrace tunable which some modules depend on
  * Fixed squid and nrpe policy
  * Made all necessary changes to allow a KDE login
    Closes: #677589
  * Made all necessary changes for a mail server running Postfix, Courier
    Maildrop, and Dovecot.  Not all mail server configurations will work (MTAs
    tend to be complex and have lots of interactions) but getting other
    configurations will be easier now.

 -- Russell Coker <russell@coker.com.au>  Sun, 17 Jun 2012 06:18:01 +0000

refpolicy (2:2.20110726-5) unstable; urgency=high

  * Add systemd support - incomplete.
    Closes: #660577.  I opened another bug for systemd not working.
  * Depend on the latest SE Linux libraries
  * Fix many problems that prevented successful boot, now should be quite
    functional for servers.
    Closes: #677579, #613977
  * Fix djbdns port access.
    Closes: #620718

 -- Russell Coker <russell@coker.com.au>  Sat, 16 Jun 2012 00:17:13 +1000

refpolicy (2:2.20110726-4) unstable; urgency=low
  [Russell Coker]
  * Build and upload based on Laurent and Mika's good work.
  * Hopefully will have a new version released very soon, but it's good to just
    upload when there have been significant changes that have no down-side.

  [Laurent Bigonville]
  * debian/control:
    - Bump Standards-Version to 3.9.2
  * Add debian/gbp.conf file
  * Switch to dpkg-source 3.0 (quilt) format
    - Split out existing patches

  [Mika Pflüger]
  * Switch to team maintenance
  * Update Vcs-* fields (Closes: #660328)

 -- Russell Coker <russell@coker.com.au>  Sun, 10 Jun 2012 12:07:17 +1000

refpolicy (2:2.20110726-3) unstable; urgency=low

  * Label /run/mdadm/map .
    Closes: #643490
  * Stop conflicting with ancient "selinux" package.
    Closes: #576598

 -- Russell Coker <russell@coker.com.au>  Wed, 25 Jan 2012 23:52:15 +1100

refpolicy (2:2.20110726-2) unstable; urgency=low

  * Merged all the patches from 2:0.2.20100524-13.
  * Allow mozilla_t to search user_home_t for ~/.config/chromium
  * Allow mozilla_t to create sym links in /tmp
  * Use a separate default setrans.conf for mls
  * Allow inetd_t setrlimit access
  * Allow mozilla_t to create socket files in /tmp, for chromium
  * Remove the hack for /run etc that was introduced in 2:0.2.20100524-10
  * Correctly label nrpe.cfg as nrpe_etc_t

 -- Russell Coker <russell@coker.com.au>  Wed, 02 Nov 2011 12:57:17 +1100

refpolicy (2:2.20110726-1) unstable; urgency=low

  * New upstream policy
  * Built for Wheezy, made it depend on all Wheezy versions.  It won't work
    on Squeeze and can't be easily backported.
  * Label /dev/xconsole as xconsole_device_t

